package cn.com.taiji.controller;

import cn.com.taiji.model.HlxAisPackage;
import cn.com.taiji.model.HlxRadarPackage;
import cn.com.taiji.protobuf.Target;
import cn.com.taiji.service.HlxAisService;
import cn.com.taiji.service.HlxRadarService;
import com.alibaba.excel.EasyExcel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.text.ParseException;
import java.util.List;

/**
 * @author kok20
 * @date 2023/3/3
 */
@RequestMapping("/protobuf")
@RestController
public class protobufController {
    @Autowired
    HlxAisService hlxAisService;
    @Autowired
    HlxRadarService hlxRadarService;

    @PostMapping("/hlxais/excel")
    public void hlxAisExcel(HttpServletResponse response) throws IOException, ParseException {
        try {
            List<HlxAisPackage> list = hlxAisService.getAisList();
            System.out.println("导出海兰信AIS原始数据");
            response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
            response.setCharacterEncoding("utf-8");
            String fileName = URLEncoder.encode("海兰信AIS原始数据", "UTF-8");
            response.setHeader("Content-Disposition", "attachment;filename=" + fileName + ".xlsx");
            EasyExcel.write(response.getOutputStream(), HlxAisPackage.class).sheet("海兰信AIS原始数据")
                    .doWrite(list);
        } catch (Exception e) {
            // 重置response
            System.out.println("导出海兰信AIS原始数据excel失败：{}" + e.getMessage() + e);
        }
    }

    @PostMapping("/hlxradar/excel")
    public void hlxRadarExcel(HttpServletResponse response) throws IOException, ParseException {
        try {
            List<HlxRadarPackage> list = hlxRadarService.getRadarList();
            System.out.println("导出海兰信雷达原始数据");
            response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
            response.setCharacterEncoding("utf-8");
            String fileName = URLEncoder.encode("海兰信雷达原始数据", "UTF-8");
            response.setHeader("Content-Disposition", "attachment;filename=" + fileName + ".xlsx");
            EasyExcel.write(response.getOutputStream(), HlxRadarPackage.class).sheet("海兰信雷达原始数据")
                    .doWrite(list);
        } catch (Exception e) {
            // 重置response
            System.out.println("导出海兰信雷达原始数据excel失败：{}" + e.getMessage() + e);
        }
    }
}
