package cn.com.taiji.model;

import cn.com.taiji.utils.ByteArrayUtils;

/**
 * @author kok20
 * @date 2023/3/4
 */
public class HlxHead {
    Long num;
    String timestamp;
    Integer type;
    Integer length;

    public String getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(String timestamp) {
        this.timestamp = timestamp;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Integer getLength() {
        return length;
    }

    public void setLength(Integer length) {
        this.length = length;
    }

    public Long getNum() {
        return num;
    }

    public void setNum(Long num) {
        this.num = num;
    }

    public static HlxHead getHeadFromByte(byte[] head) {
        HlxHead hlxHead = new HlxHead();
        if(head.length == 21){
            byte[] num = new byte[8];
            System.arraycopy(head,0,num,0,8);
            hlxHead.setNum(ByteArrayUtils.byteArray2Long_Little_Endian(num));
            byte[] timestamp = new byte[8];
            System.arraycopy(head,8,timestamp,0,8);
            Long stamp = ByteArrayUtils.byteArray2Long_Little_Endian(timestamp);
            hlxHead.setTimestamp(String.valueOf(stamp));
            byte[] type = new byte[1];
            System.arraycopy(head,16,type,0,1);
            int t = type[0]&255;
            hlxHead.setType(t);
            byte[] length = new byte[4];
            System.arraycopy(head,17,length,0,4);
            hlxHead.setLength(ByteArrayUtils.byteArray2Int_Little_Endian(length));
        }
        return hlxHead;
    }
}
