package cn.com.taiji.service.impl;

import cn.com.taiji.enetity.HlxAis;
import cn.com.taiji.mapper.HlxAisMapper;
import cn.com.taiji.model.HlxAisPackage;
import cn.com.taiji.service.HlxAisService;
import cn.com.taiji.utils.ByteArrayUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @author kok20
 * @date 2023/3/3
 */@Service
@Slf4j
public class HlxAisServiceImpl extends ServiceImpl<HlxAisMapper, HlxAis> implements HlxAisService {
    private Vector<HlxAisPackage> targetAis = new Vector<>();

    @Override
    public void saveRadarList() {
        List<HlxAisPackage> result = new ArrayList<> (targetAis);
        List<HlxAis> saveList = new ArrayList<> ();
        targetAis = new Vector<>();
        for (HlxAisPackage p : result) {
            HlxAis ais = new HlxAis();
            ais.setHeader(p.getHead());
            ais.setValue(p.getAisList());
            ais.setCreateTime(new Date());
            saveList.add(ais);
        }
        saveBatch(saveList);
    }

    @Override
    public void putAisList(HlxAisPackage p) {
        targetAis.add(p);
    }

    @Override
     public List<HlxAisPackage> getAisList() {
        List<HlxAisPackage> result = new ArrayList<> (targetAis);
        targetAis.clear();
        return result;
     }

    public static void main(String[] args) {

        byte[] result = new byte[21];
        result[0] = 0x69;
        result[1] = 0x20;
        result[2] = (byte) 0x91;
        result[3] = 0x01;
        result[4] = 0x00;
        result[5] = 0x00;
        result[6] = 0x00;
        result[7] = 0x00;
        result[8] = (byte) 0xFD;
        result[9] = 0x1C;
        result[10] = 0x0C;
        result[11] = (byte) 0xA8;
        result[12] = (byte) 0x86;
        result[13] = (byte) 0x01;
        result[14] = (byte) 0x00;
        result[15] = (byte) 0x00;
        result[16] = (byte) 0x02;
        result[17] = (byte) 0x4E;
        result[18] = (byte) 0x00;
        result[19] = (byte) 0x00;
        result[20] = (byte) 0x00;
        System.out.println("protobuf数据bytes[]:" + ByteArrayUtils.bytes2hexDisplayHex(result));
//        byte[] num = new byte[8];
//        System.arraycopy(result,0,num,0,8);
//        System.out.println("num:" + ByteArrayUtils.byteArray2Long_Little_Endian(num));
//        byte[] timestamp = new byte[8];
//        System.arraycopy(result,8,timestamp,0,8);
//        System.out.println("timestamp:" + ByteArrayUtils.byteArray2Long_Little_Endian(timestamp));
//        byte[] type = new byte[1];
//        System.arraycopy(result,16,type,0,1);
//        int i = type[0]&255;
//        System.out.println("type:" + i);
//        byte[] lenth = new byte[4];
//        System.arraycopy(result,17,lenth,0,4);
//        System.out.println("lenth:" + ByteArrayUtils.byteArray2Int_Little_Endian(lenth));
    }
}
