package cn.com.taiji.service.impl;

import cn.com.taiji.enetity.HlxRadar;
import cn.com.taiji.mapper.HlxRadarMapper;
import cn.com.taiji.model.HlxRadarPackage;
import cn.com.taiji.service.HlxRadarService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Vector;

/**
 * @author kok20
 * @date 2023/3/3
 */
@Service
public class HlxRadarServiceImpl extends ServiceImpl<HlxRadarMapper, HlxRadar> implements HlxRadarService {
    private Vector<HlxRadarPackage> targetRadar = new Vector<>();

    @Override
    public void putRadarList(HlxRadarPackage p) {
        targetRadar.add(p);
    }

    @Override
    public List<HlxRadarPackage> getRadarList() {
        List<HlxRadarPackage> result = new ArrayList<> (targetRadar);
        targetRadar.clear();
        return result;
    }
    @Override
    @Scheduled(initialDelay = 5 * 1000, fixedRate = 30 * 1000)
    public void saveRadarList() {
        if (targetRadar.isEmpty()){
            return;
        }
        List<HlxRadarPackage> result = new ArrayList<> (targetRadar);
        List<HlxRadar> saveList = new ArrayList<> ();
        targetRadar.clear();
        for (HlxRadarPackage p : result) {
            HlxRadar radar = new HlxRadar();
            radar.setHeader(p.getHead());
            radar.setValue(p.getRadarList());
            radar.setCreateTime(new Date());
            saveList.add(radar);
        }
        saveBatch(saveList);
        System.out.println("保存原始雷达数据: " + saveList.size()+"条");
    }

}
